## r-base 4.0.4

=== DESCRIPTION ===
Package: nlme
Version: 3.1-152
Date: 2021-02-03
Priority: recommended
Title: Linear and Nonlinear Mixed Effects Models
Authors@R: c(person("José", "Pinheiro", role = "aut", comment = "S version"),
             person("Douglas", "Bates", role = "aut", comment = "up to 2007"),
             person("Saikat", "DebRoy", role = "ctb", comment = "up to 2002"),
             person("Deepayan", "Sarkar", role = "ctb", comment = "up to 2005"),
             person("EISPACK authors", role = "ctb", comment = "src/rs.f"),
	     person("Siem", "Heisterkamp", role = "ctb", comment = "Author fixed sigma"),
             person("Bert", "Van Willigen",role = "ctb", comment = "Programmer fixed sigma"),
             person("Johannes", "Ranke", role = "ctb", comment = "varConstProp()"),
	     person("R-core", email = "R-core@R-project.org",
                    role = c("aut", "cre")))
Contact: see 'MailingList'
Description: Fit and compare Gaussian linear and nonlinear mixed-effects models.
Depends: R (>= 3.4.0)
Imports: graphics, stats, utils, lattice
Suggests: Hmisc, MASS
LazyData: yes
ByteCompile: yes
Encoding: UTF-8
License: GPL (>= 2) | file LICENCE
BugReports: https://bugs.r-project.org
MailingList: R-help@r-project.org
URL: https://svn.r-project.org/R-packages/trunk/nlme/
NeedsCompilation: yes
Packaged: 2021-02-03 21:06:11 UTC; ripley
Author: José Pinheiro [aut] (S version),
  Douglas Bates [aut] (up to 2007),
  Saikat DebRoy [ctb] (up to 2002),
  Deepayan Sarkar [ctb] (up to 2005),
  EISPACK authors [ctb] (src/rs.f),
  Siem Heisterkamp [ctb] (Author fixed sigma),
  Bert Van Willigen [ctb] (Programmer fixed sigma),
  Johannes Ranke [ctb] (varConstProp()),
  R-core [aut, cre]
Maintainer: R-core <R-core@R-project.org>
Repository: CRAN
Date/Publication: 2021-02-04 07:01:32 UTC

=== src/gnuwin32/Makefile ===
R_HOME = ../..

## first time through MkRules will not exist.

ifeq ($(wildcard MkRules?local),MkRules.local)
include MkRules.local
endif

include MkRules.rules
include ../../share/make/vars.mk

MK = $(MAKE) --no-print-directory

all:
	@$(MK) MkRules
	@if test -f  ../../SVN-REVISION ; then \
	  cp ../../SVN-REVISION ../../SVN-REVISION.bak ; \
	fi
	@$(MK) rbuild
	@$(MK) -C ../library -f Makefile.win all WIN=$(WIN)
	@$(MK) -C ../library -f Makefile.win docs
	@$(MK) NEWSdocs htmldocs docfiles
	@$(MK)  -C ../../po -f Makefile.win

bytecode: bytecode-base bytecode-recommended

bytecode-base:
	@$(MK) MkRules
	@if test -f  ../../SVN-REVISION ; then \
	  cp ../../SVN-REVISION ../../SVN-REVISION.bak ; \
	fi
	@$(MK) rbuild
	@$(MK) -C ../library -f Makefile.win bytecode WIN=$(WIN)
	@$(MK) -C ../library -f Makefile.win docs
	@$(MK) NEWSdocs htmldocs docfiles
	@$(MK)  -C ../../po -f Makefile.win


rpackages:
	@$(MK) -C ../library -f Makefile.win all WIN=$(WIN) EXT_LIBS="$(EXT_LIBS)"
	@$(MK) -C ../library -f Makefile.win docs


cairodevices:
ifneq "$(USE_CAIRO)" ""
	@$(MK) -C ../library/grDevices/src/cairo -f Makefile.win all \
	  WIN=$(WIN) CAIRO_LIBS=$(CAIRO_LIBS) CAIRO_CPPFLAGS=$(CAIRO_CPPFLAGS)
endif

ifeq ($(wildcard MkRules?local),MkRules.local)
MkRules: MkRules.local MkRules.rules
	@cat MkRules.local MkRules.rules > MkRules
else
MkRules: MkRules.rules
	@cat MkRules.rules > MkRules
endif

CFLAGS = -O3 -Wall -pedantic $(EOPTS)
FFLAGS = -O3 $(EOPTS) $(GF7OPTS)

ifdef DEBUG
 CFLAGS += $(G_FLAG)
 FFLAGS += $(G_FLAG)
 DLLFLAGS =
else
 DLLFLAGS = -s
endif


R-DLLFLAGS = -mwindows
LIBEXTRAS = -L"$(EXT_LIBS)"/lib$(R_ARCH) -lpcre2-8 -lz -lbz2 -llzma
ifdef USE_ICU
LIBEXTRAS += -L"$(ICU_PATH)"/lib$(R_ARCH) $(ICU_LIBS)
endif

dllversion-RESFLAGS = -I../include
CSOURCES = \
  console.c dynload.c editor.c embeddedR.c extra.c malloc.c \
  opt.c pager.c preferences.c psignal.c rhome.c rt_complete.c \
  rui.c run.c shext.c sys-win32.c system.c dos_wglob.c
OBJS = $(CSOURCES:.c=.o) dllversion.o
ifeq "$(WIN)" "32"
 OBJS += e_pow.o
endif
MAINLIBS = ../main/libmain.a ../appl/libappl.a ../nmath/libnmath.a
EXTRALIBS = getline/gl.a ../extra/xdr/libxdr.a \
   ../extra/intl/libintl.a ../extra/trio/libtrio.a ../extra/tzone/libtz.a \
   ../extra/tre/libtre.a

R-DLLLIBS = $(OPENMP) -L. $(FLIBS) -lRblas -L../../$(IMPDIR) -lRgraphapp \
  -lRiconv -lcomctl32 -lwinmm -lversion $(LIBEXTRAS)


.PHONY:  clean veryclean rlibs fixfiles front-ends rmodules


CPPFLAGS = -I../include -I. -I../extra -DHAVE_CONFIG_H -DR_DLL_BUILD
extra-CPPFLAGS = -I../library/grDevices/src

Rpwd.exe: front-ends/Rpwd.exe
	$(CP) $< $@

front-ends/Rpwd.exe:
	$(MK) -C front-ends Rpwd

## watch out: R.dll and Rblas.dll depend on each other.
rbuild:
	@$(MK) fixfiles
	@$(MK) -C ../include -f Makefile.win
	@$(MK) -C ../scripts -f Makefile.win
ifdef USE_IMPLIBS
	@$(MK) libRiconv.dll.a
endif
	@$(MK) libRblas.dll.a
	@$(MK) ../../$(BINDIR)/R.dll
ifdef USE_IMPLIBS
	@$(MK) implibs
endif
	@$(MK) Rblas
	@$(MK) front-ends COPYRIGHTS rmodules fixed/fixdesc


rlibs:
	$(MK) -C ../extra/intl CFLAGS='$(CFLAGS)' -f Makefile.win
	$(MK) -C ../appl CFLAGS='$(CFLAGS)' FFLAGS='$(FFLAGS)' -f Makefile.win
	$(MK) -C ../nmath CFLAGS='$(CFLAGS)' FFLAGS='${FFLAGS}' -f Makefile.win
	$(MK) -C ../main CFLAGS='$(CFLAGS)' FFLAGS='$(FFLAGS)' malloc-DEFS='$(malloc-DEFS)' -f Makefile.win
	$(MK) -C ./getline CFLAGS='$(CFLAGS)'
	@for ex in graphapp xdr tre trio tzone win_iconv ; do \
	  $(MK) -C ../extra/$${ex} CFLAGS='$(CFLAGS)' -f Makefile.win || exit 1; \
	done

rmodules:
	@$(MKDIR) -p ../../modules$(R_ARCH)
	$(MK) -C ../modules -f Makefile.win \
	  CFLAGS='$(CFLAGS)' FFLAGS='$(FFLAGS)'

COPYRIGHTS: ../../doc/COPYRIGHTS COPYRIGHTS.win
	cat $^ > $@


fixfiles: Rpwd.exe
	@$(MKDIR) -p ../../$(BINDIR)
	@$(MK) -C ./fixed
ifdef USE_LIBCURL
	@if test -f "$(CURL_PATH)/etc/curl-ca-bundle.crt"; then \
	  $(CP) -p "$(CURL_PATH)/etc/curl-ca-bundle.crt" ../../etc; \
	elif test -f "$(CURL_CA_BUNDLE)"; then \
	  $(CP) -p "$(CURL_CA_BUNDLE)" ../../etc/curl-ca-bundle.crt; \
	fi
endif

fixed/fixdesc:
	@sh fixed/GETDESC $(R_PKGS_BASE) translations

dllversion.o: ../include/Rversion.h

## Rdll.hide has decoration which 64-bit builds lack
ifeq "$(WIN)" "64"
R.dll: $(OBJS) $(MAINLIBS) $(EXTRALIBS)
	@$(ECHO) EXPORTS > R.def
	@$(NM) $^ | $(SED) -n  $(SYMPAT) | LC_COLLATE=C $(SORT) | \
	  uniq $(NM_FILTER) > R0.def
	@$(SED) -e's/@.*//' Rdll.hide | LC_COLLATE=C $(SORT) > R1.def
	@LC_COLLATE=C comm -23 R0.def R1.def >> R.def
	$(DLL) -shared $(DLLFLAGS) $($*-DLLFLAGS) -o $@ R.def $^ $($*-DLLLIBS) $(DLLLIBS)
	@$(RM) R.def R0.def R1.def
else
R.dll: $(OBJS) $(MAINLIBS) $(EXTRALIBS)
	@$(ECHO) EXPORTS > R.def
	@$(NM) $^ | $(SED) -n  $(SYMPAT) | LC_COLLATE=C $(SORT) | uniq > R0.def
	@LC_COLLATE=C $(SORT) Rdll.hide > R1.def
	@LC_COLLATE=C comm -23 R0.def R1.def >> R.def
	$(DLL) -shared $(DLLFLAGS) $($*-DLLFLAGS) -o $@ R.def $^ $($*-DLLLIBS) $(DLLLIBS)
	@$(RM) R.def R0.def R1.def
endif

R.exp: $(OBJS) $(MAINLIBS) $(EXTRALIBS)
	@$(ECHO) LIBRARY R.dll > R.exp
	@$(ECHO) EXPORTS >> R.exp
	@$(NM) $^ | $(SED) -n $(SYMPAT) | LC_COLLATE=C $(SORT) | \
	  uniq $(NM_FILTER) > R0.def
	@LC_COLLATE=C comm -23 R0.def Rdll.hide >> R.exp
	@$(RM) R0.def


Rdll: makeMakedeps libRblas.dll.a ../../$(BINDIR)/R.dll

../../$(BINDIR)/R.dll: FORCE
	@$(MK) fixfiles
	@$(MK) -C ../include -f Makefile.win
	@$(MK) rlibs
	@$(MK) makeMakedeps
	@$(MK) R.dll
	@$(MKDIR) -p ../../$(BINDIR)
	$(CP) R.dll ../../$(BINDIR)

FORCE:

implibs: libR.dll.a libRblas.dll.a
	@$(MKDIR) -p ../../lib
	@$(CP) $^ ../../lib

libR.dll.a: R.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll \
	  --input-def $< --output-lib $@

libRiconv.dll.a: unicode/iconv.def
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname Riconv.dll \
	  --input-def $< --output-lib $@


front-ends:
	$(MK) -C front-ends

../extra/tre/libtre.a:
	$(MK) -C ../extra/tre -f Makefile.win

../extra/trio/libtrio.a:
	$(MK) -C ../extra/trio -f Makefile.win

NEWSdocs:
	@$(MK) -C ../../doc -f Makefile.win

htmldocs:
	@$(ECHO)
	@$(ECHO) "------ Making HTML documentation ------"
	@$(MK) -C ../../doc/manual -f Makefile.win html


#                          ===== BLAS ======

Rblas:
	@$(MK) -C ../extra/blas -f Makefile.win FFLAGS='-O2 $(EOPTS)'

Rblas-clean:
	@$(MK) -C ../extra/blas -f Makefile.win clean

libRblas.dll.a:  ../extra/blas/Rblas.def
	@$(DLLTOOL) $(DLLTOOLFLAGS) --dllname Rblas.dll \
	  --input-def $< --output-lib $@


#                          ===== cleaning ======

## used in installer/Makefile
PKGDIR = ../library
pkgclean-%:
	@(cd $(PKGDIR)/$*/src; rm -f *.d *.o *.dll *_res.rc Makedeps)

EXTRA_DIRS = blas graphapp intl tre trio tzone xdr win_iconv

cleaninstaller:
	-$(MAKE) -C installer clean

# The installer has to be cleaned first, because cleaning it depends on Rscript
#   clean0 and cleanwin0 exclude the installer
#   clean, distclean and cleanwin clean also the installer 
clean0: cleanwin0
	@$(MAKE) -C ../library -f Makefile.win clean
	$(RM) -f ../*/*.o ../*/*.a *.a ../*/*.d ../*/Makedeps fixed/fixdesc
	@for d in $(EXTRA_DIRS); do \
	  $(MAKE) -C ../extra/$${d} -f Makefile.win clean; \
	done
	-$(MK) -C ../../doc/manual -f Makefile.win distclean
	-$(MK) -C ../nmath/standalone -f Makefile.win distclean
	-$(MK) -C ../modules -f Makefile.win clean
	-$(MK) -C ../../tests -f Makefile.win clean
	-$(MK) -C ../library/Recommended -f Makefile.win clean
	$(RM) -f ../library/methods/all.R ../../etc/curl-ca-bundle.crt

clean: cleaninstaller clean0

distcleaninstaller:
	-$(MAKE) -C installer distclean 

distclean: cleaninstaller distcleaninstaller clean0
	@for d in $(EXTRA_DIRS); do \
	  $(MAKE) -C ../extra/$${d} -f Makefile.win distclean; \
	done
	@$(MAKE) -C ../../tests -f Makefile.win distclean
	$(RM) -R ../../bin ../../include ../../lib ../../library ../../modules
	$(RM) ../include/config.h ../include/iconv.h ../include/psignal.h \
	../include/Rconfig.h ../include/Rversion.h ../include/Rmath.h \
	../include/libintl.h ../include/trioremap.h
	$(RM) ../library/*/src/*.o ../library/*/src/*.a
	$(RM) ../library/*/src/*.d ../library/*/src/Makedeps
	$(RM) ../library/*/src/*.dll
	$(RM) ../library/*/src/windows/*.o ../library/*/src/windows/*.a
	$(RM) ../library/*/src/windows/*.d ../library/*/src/windows/Makedeps
	$(RM) ../library/*/src/windows/*.dll
	$(RM) -R ../library/*/check
	$(RM) ../library/*/tests/*.ps ../library/*/tests/*.pdf
	$(RM) ../library/tcltk/src/tcl$(TCL_VERSION).def \
	../library/tcltk//src/tk$(TCL_VERSION).def
	$(RM) R.exp COPYRIGHTS
	$(RM) ../../doc/html/index.html \
	../../doc/html/packages.html ../../doc/html/rwin.html \
	../../doc/html/rw-FAQ.html ../../doc/html/NEWS.html \
	../../doc/NEWS.rds ../../doc/NEWS.3.rds ../../doc/NEWS.2.rds \
	../../doc/NEWS ../../doc/NEWS.pdf \
	../../doc/CHANGES.rds ../../doc/html/CHANGES.html
	$(RM) ../../etc/Makeconf ../../etc/Rconsole ../../etc/Rdevga \
	../../etc/Rprofile.site ../../etc/rgb.txt ../../etc/Rcmd_environ \
	../../tests/*.Rout ../../tests/*.Rout.fail
	$(RM) -R ../../etc/i386 ../../etc/x64 # do both sub-archs
	$(RM) -R ../../share/zoneinfo
	$(MAKE) -C fixed distclean
	$(MAKE) -C ../include -f Makefile.win distclean
	@for pkg in $(R_PKGS_BASE) translations; do \
	  $(RM) ../library/$${pkg}/DESCRIPTION; \
	done
	$(RM) ../../SVN-REVISION.bak
	$(RM) ../../doc/manual/rw-FAQ
	$(MAKE) -C cran clean
	$(RM) -R ../library/.vignettes # it gets left behind if there is an error
	$(RM) -R ../../share/locale # relic of earlier versions
	$(RM) MkRules Rpwd.exe # do this last of all

veryclean: distclean
	$(RM) ../../doc/FAQ ../../doc/RESOURCES ../../doc/NEWS.rds \
	  ../../doc/html/resources.html ../../doc/html/NEWS.html \
	  ../../SVN-REVISION # not in SVN sources

cleanwin0: MkRules fixfiles
	$(RM) *.o *.dll *.a *~ \#*\# .RData .Rhistory Makedeps *.d
	$(MAKE) -C ../extra/graphapp -f Makefile.win clean
	$(MAKE) -C fixed clean
	$(MAKE) -C getline clean
	$(MAKE) -C front-ends clean
	$(MAKE) -C ../library/grDevices/src/cairo -f Makefile.win clean WIN=$(WIN)

cleanwin: cleaninstaller cleanwin0


#                          ===== testing ======

check check-devel check-all check-recommended:
	@$(MK) -C ../../tests -f Makefile.win $@

#                          ===== documentation ======

pdfdocs manuals:
	@$(MK) -C ../../doc/manual -f Makefile.win clean
	@$(MK) -C ../../doc/manual -f Makefile.win

R_EXE = ../../$(BINDIR)/Rterm.exe --vanilla --no-echo

## must come after recommended
vignettes:
	@$(MK) -C ../library -f Makefile.win vignettes


## ===================== Maintainer targets ========================

RVER-PAT = $(shell version=`cut -d' ' -f1 ../../VERSION | sed -n 1p`; if test "`cut -f2 -d' ' ../../VERSION`" = "Patched"; then version=`echo $${version} | sed 's/\.[0-9]*$$//'`; echo "$${version}-patched"; else echo "$${version}"; fi)

CRANREC = cran.r-project.org::CRAN/src/contrib/$(RVER-PAT)/Recommended

## Use -c here to avoid re-downloading the same versions of files
## A recent rsync seems to need -p
rsync-recommended:
	@(cd ../library; \
	  rsync --timeout=60 -rcvpC --delete \
	    --exclude=Makefile.in --exclude=Makefile.win --exclude=.cvsignore \
	    --include=*.tar.gz --exclude=*.tgz --exclude=*.ts \
	    --exclude=".svn" $(CRANREC) . )
	@$(RM) ../library/Recommended/*.tgz
	@(cd ../library/Recommended; for i in ${R_PKGS_RECOMMENDED}; do cp -p $${i}*.tar.gz $${i}.tgz ; done)

link-recommended:
	@$(RM) ../library/Recommended/*.tgz
	@(cd ../library/Recommended; for i in ${R_PKGS_RECOMMENDED} ; do cp -p $${i}*.tar.gz $${i}.tgz ; done)


recommended:
	@$(ECHO) "--- Making recommended packages"
	@$(MK) -C ../library/Recommended -f Makefile.win

## Note that R_COMPILER_SUPPRESS_ALL is now on by default
bytecode-recommended:
	@$(ECHO) "--- Making and compiling recommended packages"
	@rm ../library/Recommended/*.ts
	@R_COMPILE_PKGS=1 R_COMPILER_SUPPRESS_ALL=1 \
	  $(MK) -C ../library/Recommended -f Makefile.win

RVER-MAJOR-MINOR = $(shell echo `cut -d'.' -f1,2 ../../VERSION`)

=== src/gnuwin32/cran/Makefile ===
include ../MkRules

R_HOME = ../../..

RPREFIX = $(shell ../../../bin$(R_ARCH)/Rscript ../fixed/rwver.R)
FULLVERSION=`cat ../../../VERSION`
SVNREVISION=`sed -e 1s/Revision:.// -e q < $(R_HOME)/SVN-REVISION`
RVER = $(shell cut -d' ' -f1 ../../../VERSION | sed -n 1p)
DATE = $(shell date +%F)
SIZEMB = $(shell du -m ../installer/$(RPREFIX)-win.exe | cut -f1)

R_EXE = $(R_HOME)/$(BINDIR)/rterm.exe --vanilla --no-echo

all:
	$(CP) ../../../doc/html/CHANGES.html CHANGES.$(RPREFIX).html
	$(CP) ../../../doc/html/NEWS.html NEWS.$(RPREFIX).html
	$(CP) ../installer/$(RPREFIX)-win*.exe .
	($(ECHO) 'cat(md5sum("$(RPREFIX)-win.exe"), "*$(RPREFIX)-win.exe")' \
         | $(R_EXE) R_DEFAULT_PACKAGES=tools > md5sum.txt)
	$(CP) ../../../doc/html/rw-FAQ.html .	
	@for page in index rdevel rpatched rtest release; do \
	  $(SED) -e s/@RWVER@/$(RPREFIX)/g \
	    -e s/@RVER@/$(RVER)/g \
	    -e "s/@DATE@/$(DATE)/g" \
	    -e "s/@SIZEMB@/$(SIZEMB)/g" \
	    -e "s/@SVNREVISION@/$(SVNREVISION)/g" \
	    -e "s/@FULLVERSION@/$(FULLVERSION)/g" $${page}.in >$${page}.html; \
	done
	$(CP) release.html release.htm
	$(SED) -e s/@RWVER@/$(RPREFIX)/g \
	  -e s/@RVER@/$(RVER)/g \
	  -e "s/@FULLVERSION@/$(FULLVERSION)/g" ../README > README.$(RPREFIX)
	$(SED) -e s/@RWVER@/$(RPREFIX)/g \
	  -e s/@RVER@/$(RVER)/g \
	  -e "s/@FULLVERSION@/$(FULLVERSION)/g" ReadMe.in > ReadMe	  
	@(zip -q dosfiles.zip CHANGES.$(RPREFIX) NEWS.$(RPREFIX) README.$(RPREFIX) ReadMe; \
	 unzip -aqo dosfiles.zip; \
	 $(RM) dosfiles.zip)
	$(ECHO) set target=$(RPREFIX) >target.cmd


clean:
	$(RM) -R *.html *.htm ReadMe README* *.exe md5sum.txt NEWS.* CHANGES.* target.cmd

=== src/gnuwin32/fixed/Makefile ===
include ../MkRules

R_HOME = ../../..

# FIXME:  Should find a make where $(abspath ...) works and avoid this...
LOCAL_SOFT := $(shell ../Rpwd.exe $(LOCAL_SOFT))

all: profiles fixhtml fixetc fixdoc svnonly

profiles: $(R_HOME)/library/base/R/Rprofile

$(R_HOME)/library/base/R/Rprofile:  ../../library/profile/Common.R \
../../library/profile/Rprofile.windows
	@$(ECHO) -------- Building $@ from $^--------
	mkdir -p $(R_HOME)/library/base/R
	@$(CAT)  $^ > $@

fixhtml:  html/rwin.html
	$(CP) -p html/rwin.html $(R_HOME)/doc/html/index.html
	@$(ECHO) done > fixhtml

ETC = $(wildcard ./etc/*)
fixetc: $(ETC) ../MkRules Makefile
	$(CP) -p $(ETC) $(R_HOME)/etc
	$(RM) $(R_HOME)/etc/Makeconf
	$(MKDIR) -p $(R_HOME)/etc/$(R_ARCH)
ifeq "$(WIN)" "64"
	$(SED) -e 's/WIN = 32/WIN = 64/' \
	  -e "s/-O3/-O2/" \
	  -e "s/@EOPTS@/$(EOPTS)/" \
	  -e "s|BINPREF =|BINPREF ?= $(BINPREF)|" \
	  -e "s|COMPILED_BY =|COMPILED_BY = $(COMPILED_BY)|" \
	  -e "s|IMPDIR = bin|IMPDIR = $(IMPDIR)|" \
	  -e "s|LOCAL_SOFT ?=|LOCAL_SOFT ?= $(LOCAL_SOFT)|" \
	  -e "s|R_ARCH =|R_ARCH = $(R_ARCH)|" \
	  -e "s|DT_ARCH =|DT_ARCH = $(DT_ARCH)|" \
	  -e "s|RC_ARCH =|RC_ARCH = $(RC_ARCH)|" \
	  -e "s|M_ARCH =|M_ARCH = $(M_ARCH)|" \
	  -e "s|@SYMPAT@|$(SYMPAT)|" \
	  -e "s|(TCL_HOME)/bin|(TCL_HOME)/bin64|" \
	  -e "s|@OPENMP@|$(OPENMP)|" \
	  -e "s|@PTHREAD@|$(PTHREAD)|" \
	  -e "s@NM_FILTER =@NM_FILTER = $(NM_FILTER)@" \
	  -e "s|@GF7OPTS@|$(GF7OPTS)|" \
	  etc/Makeconf > $(R_HOME)/etc$(R_ARCH)/Makeconf
else
	$(SED) -e "s|IMPDIR = bin|IMPDIR = $(IMPDIR)|" \
	  -e "s/-O3/-O2/" \
	  -e "s/@EOPTS@/$(EOPTS)/" \
	  -e "s|BINPREF =|BINPREF ?= $(BINPREF)|" \
	  -e "s|COMPILED_BY =|COMPILED_BY = $(COMPILED_BY)|" \
	  -e "s|LOCAL_SOFT ?=|LOCAL_SOFT ?= $(LOCAL_SOFT)|" \
	  -e "s|R_ARCH =|R_ARCH = $(R_ARCH)|" \
	  -e "s|DT_ARCH =|DT_ARCH = $(DT_ARCH)|" \
	  -e "s|RC_ARCH =|RC_ARCH = $(RC_ARCH)|" \
	  -e "s|M_ARCH =|M_ARCH = $(M_ARCH)|" \
	  -e "s|@SYMPAT@|$(SYMPAT)|" \
	  -e "s|@OPENMP@|$(OPENMP)|" \
	  -e "s|@PTHREAD@|$(PTHREAD)|" \
	  -e "s@NM_FILTER =@NM_FILTER = $(NM_FILTER)@" \
	  -e "s|@GF7OPTS@|$(GF7OPTS)|" \
	  etc/Makeconf > $(R_HOME)/etc$(R_ARCH)/Makeconf
endif
	$(SED) -e "s+@BINDIR@+$(BINDIR)+" Makeconf > $(R_HOME)/Makeconf
	@$(ECHO) done > fixetc

fixdoc: $(wildcard ../CHANGES?)
	$(CP) -p $^ $(R_HOME)/doc
	@$(ECHO) done > fixdoc

svnonly:
	@$(MAKE) -C ../../../doc/manual -f Makefile.win svnonly

clean:
	$(RM) *~ */*~ fixhtml fixbin fixetc fixshare fixdoc

distclean:
	$(RM) $(R_HOME)/doc/CHANGES* $(R_HOME)/Makeconf

=== src/gnuwin32/front-ends/Makefile ===
include ../MkRules
R_HOME = ../../..

CFLAGS = -O3 -Wall -pedantic
ifdef DEBUG
 CFLAGS += $(G_FLAG)
 LINKFLAGS =
 DLLFLAGS =
else
 LINKFLAGS = -s
 DLLFLAGS = -s
endif
CPPFLAGS = -I../../include $(arch_DEFS)

ifeq "$(WIN)" "32"
## Increase stack size to 16Mb
LARGE_STACK = -Wl,--stack=0x1000000
## allow 32-bit builds to address over 2Gb
LARGE_ADDR = -Wl,--large-address-aware
else
## Increase stack size to 64Mb
LARGE_STACK = -Wl,--stack=0x4000000
endif

rcmdfn-CFLAGS = -DBINDIR='"$(BINDIR)"'

.PHONY : all makeMakedeps

all: makeMakedeps \
     $(R_HOME)/$(BINDIR)/Rgui.exe $(R_HOME)/$(BINDIR)/Rterm.exe \
     $(R_HOME)/$(BINDIR)/Rcmd.exe  $(R_HOME)/$(BINDIR)/RSetReg.exe  \
     $(R_HOME)/$(BINDIR)/R.exe\
     $(R_HOME)/$(BINDIR)/Rscript.exe $(R_HOME)/$(BINDIR)/open.exe \
     $(R_HOME)/$(BINDIR)/Rfe.exe \
     $(R_HOME)/bin/R.exe $(R_HOME)/bin/Rscript.exe 

$(R_HOME)/$(BINDIR)/Rgui.exe: Rgui.exe
	$(MKDIR) -p $(R_HOME)/$(BINDIR)
	$(CP) $^ $@

$(R_HOME)/$(BINDIR)/Rterm.exe: Rterm.exe
	$(MKDIR) -p $(R_HOME)/$(BINDIR)
	$(CP) $^ $@	

$(R_HOME)/$(BINDIR)/Rcmd.exe: Rcmd.exe
	$(MKDIR) -p $(R_HOME)/$(BINDIR)
	$(CP) $^ $@

$(R_HOME)/$(BINDIR)/RSetReg.exe: RSetReg.exe
	$(MKDIR) -p $(R_HOME)/$(BINDIR)
	$(CP) $^ $@

$(R_HOME)/$(BINDIR)/R.exe: R.exe
	$(MKDIR) -p $(R_HOME)/$(BINDIR)
	$(CP) $^ $@	

$(R_HOME)/$(BINDIR)/Rfe.exe: Rfe.exe
	$(MKDIR) -p $(R_HOME)/$(BINDIR)
	$(CP) $^ $@

$(R_HOME)/bin/R.exe: Rfe.exe
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@	

$(R_HOME)/bin/Rscript.exe: Rfe.exe
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@	

$(R_HOME)/$(BINDIR)/Rscript.exe: Rscript.exe
	$(MKDIR) -p $(R_HOME)/$(BINDIR)
	$(CP) $^ $@	

$(R_HOME)/$(BINDIR)/open.exe: open.exe
	$(MKDIR) -p $(R_HOME)/$(BINDIR)
	$(CP) $^ $@	

rgui-CPPFLAGS = -DWin32
rterm-CPPFLAGS = -DWin32

## -luser32 -lkernel32 -ladvapi32 -lshell32 are now standard
Rgui-LIBS = -L../../../$(IMPDIR) -lR -lRgraphapp
Rscript-LIBS = -L../../../$(IMPDIR) -lR -lRgraphapp -lshlwapi
Rterm-LIBS = -L../../../$(IMPDIR) -lR -lRgraphapp -lshlwapi

Rgui-LINKFLAGS = -mwindows $(LARGE_ADDR) $(LARGE_STACK)
Rterm-LINKFLAGS = $(LARGE_ADDR) $(LARGE_STACK)
Rscript-LINKFLAGS = $(LARGE_ADDR) $(LARGE_STACK)

Rgui.exe: graphappmain.o rgui.o rgico.o
Rterm.exe: graphappmain.o rterm.o rtico.o

ifneq "$(WIN)" "64"
rcico.o: Rcmd.exe.manifest
rgico.o: Rgui32.manifest
rsico.o: Rscript.exe.manifest
rtico.o: Rterm32.manifest
else
RESFLAGS = -DWN64
rcico.o: Rcmd64.exe.manifest
rtico.o: Rterm64.manifest
rsico.o: Rscript64.exe.manifest
rgico.o: Rgui64.manifest
endif

Rcmd.exe: rcmd.o ../rhome.o ../shext.o rcico.o rcmdfn.o Renviron.o

R.exe: R.o ../rhome.o ../shext.o rcico.o rcmdfn.o Renviron.o

Rfe.exe: Rfe.o ../rhome.o rcico.o

RSetReg.exe: RSetReg.o ../rhome.o rcico.o

Rscript.o: ../../unix/Rscript.c ../../include/Rversion.h
	$(CC) $(CFLAGS) -DBINDIR='"$(BINDIR)"' -I. -I../../include -DHAVE_CONFIG_H -c $< -o $@

Rscript.exe: Rscript.o rsico.o 

## Used only in writing etc/.../Makeconf
Rpwd:
	$(MAKE) -C ../../include -f Makefile.win version
	$(MAKE) Rpwd.exe

Rpwd.exe: rpwd.o rcico.o

rcmd.o R.o rgui.o rterm.o RSetReg.o rgico.o rtico.o rcico.o rsico.c: ../../include/Rversion.h

open.o: open.c
open.exe: open.o

clean:
	$(RM) *.o *.obj *.exe *~ *.exp *.dll *.lib *.a *.d Makedeps

CSOURCES = $(filter-out R.c rcmd.c rpwd.c rtest.c, $(wildcard *.c))
DEPS = $(CSOURCES:.c=.d)

makeMakedeps: $(DEPS)
	@$(RM) Makedeps
ifneq ($(strip $(DEPS)),)
	@cat $(DEPS) >> Makedeps
endif

-include Makedeps

=== debian/changelog ===
r-base (4.0.4-1) unstable; urgency=medium

  * New upstream version released this morning

  * debian/r-base-core.postinst: Improved logic for /usr/local/lib/R
    creation					(Closes: #982069)
  * debian/watch: Updated

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 15 Feb 2021 06:58:58 -0600

=== debian/control ===
Source: r-base
Section: gnu-r
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Standards-Version: 4.5.1
Build-Depends: gcc (>= 4:4.1.0), g++ (>= 4:4.1.0), gfortran (>= 4:4.1.0), libblas-dev, liblapack-dev (>= 3.1.1), tcl8.6-dev, tk8.6-dev, bison, groff-base, libncurses5-dev, libreadline-dev, debhelper-compat (= 11), texinfo (>= 4.1-2), libbz2-dev, liblzma-dev, libpcre2-dev, libpcre3-dev, libcurl4-openssl-dev | libcurl4-dev, xdg-utils, zlib1g-dev, libpng-dev, libjpeg-dev, libx11-dev, libxt-dev, x11proto-core-dev, libpango1.0-dev, libcairo2-dev, libtiff5-dev, xvfb, xauth, xfonts-base, texlive-base, texlive-latex-base, texlive-plain-generic, texlive-fonts-recommended, texlive-fonts-extra, texlive-extra-utils, texlive-latex-recommended, texlive-latex-extra, default-jdk [!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386] | openjdk-10-jdk [!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], mpack, bash-completion
Vcs-Browser: https://salsa.debian.org/edd/r-base
Vcs-Git: https://salsa.debian.org/edd/r-base.git
Homepage: http://www.r-project.org/

Package: r-base
Architecture: all
Depends: ${misc:Depends}, r-base-core (>= ${source:Version}), r-recommended (= ${source:Version})
Recommends: r-base-html, r-doc-html
Suggests: elpa-ess, r-doc-info | r-doc-pdf  
Description: GNU R statistical computation and graphics system
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available from 
 CRAN, the Comprehensive R Archive Network, many also as Debian packages, 
 named 'r-cran-<name>'.
 .
 This package is a metapackage which eases the transition from the 
 pre-1.5.0 package setup with its larger r-base package. Once installed, it 
 can be safely removed and apt-get will automatically upgrade its components
 during future upgrades.  Providing this package gives a way to users to 
 then only install r-base-core if they so desire.

Package: r-base-core
Architecture: any
Depends: ${misc:Depends}, ${perl:Depends}, zip, unzip, libpaper-utils, xdg-utils, ${shlibs:Depends}, ucf (>= 3.0), ca-certificates
Replaces: r-base (<= 1.4.1-1), r-recommended (<< 1.9.0), r-gnome (<= 2.3.1), r-cran-rcompgen (<= 0.1-17-1), r-base-latex (<= 2.9.2-4)
Provides:  r-gnome, r-cran-rcompgen, r-base-latex, r-api-4.0
Conflicts:  r-gnome, r-cran-rcompgen, r-base-latex
Recommends: r-recommended, r-base-dev, r-doc-html
Suggests: elpa-ess, r-doc-info | r-doc-pdf, r-mathlib, r-base-html
Breaks: r-bioc-graph (<< 1.62.0-1~),
        r-cran-bbmle (<< 1.0.20-5~),
        r-cran-biocmanager (<< 1.30.4+dfsg-2~),
        r-cran-caret (<< 6.0-84-2~),
        r-cran-cmprsk (<< 2.2-8-1~),
        r-cran-coin (<< 1.3-0-1~),
        r-cran-dendextend (<< 1.12.0+dfsg-1~),
        r-cran-fields (<< 9.8-3-1~),
        r-cran-filehash (<< 2.4-2-2~),
        r-cran-future (<< 1.14.0+dfsg-1~),
        r-cran-genetics (<< 1.3.8.1.2-1~),
        r-cran-haplo.stats (<< 1.7.9-4~),
        r-cran-igraph (<< 1.2.4.1-1~),
        r-cran-lava (<< 1.6.5-1~),
        r-cran-libcoin (<< 1.0-4-1~),
        r-cran-msm (<< 1.6.7-1~),
        r-cran-permute (<< 0.9-5-1~),
        r-cran-phangorn (<< 2.5.5-1~),
        r-cran-popepi (<< 0.4.7-1~),
        r-cran-recipes (<< 0.1.6-1~),
        r-cran-sp (<< 1:1.3-1-2~),
        r-cran-spam (<< 2.2-2-1~),
        r-cran-units (<< 0.6-3-1~),
        r-cran-vegan (<< 2.5-5+dfsg-1~),
        r-cran-zelig (<< 5.1.6.1-1~)
Description: GNU R core of statistical computation and graphics system
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available
 from CRAN, the Comprehensive R Archive Network, many also as Debian
 packages, named 'r-cran-<name>'.
 .
 This package provides the core GNU R system from which only the optional
 documentation packages r-base-html, r-doc-html, r-doc-pdf and r-doc-info 
 have been split off to somewhat reduce the size of this package. 

Package: r-base-dev
Architecture: all
Depends: ${misc:Depends}, r-base-core (>= ${source:Version}), build-essential, gcc, g++, gfortran, libblas-dev | libatlas-base-dev, liblapack-dev | libatlas-base-dev, libncurses5-dev, libreadline-dev, libjpeg-dev, libpcre2-dev, libpcre3-dev, libpng-dev, zlib1g-dev, libbz2-dev, liblzma-dev, libicu-dev, xauth, pkg-config
Suggests: texlive-base, texlive-latex-base, texlive-plain-generic, texlive-fonts-recommended, texlive-fonts-extra, texlive-extra-utils, texlive-latex-recommended, texlive-latex-extra, texinfo
Description: GNU R installation of auxiliary GNU R packages 
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available from 
 CRAN, the Comprehensive R Archive Network, many also as Debian packages, 
 named 'r-cran-<name>'.
 .
 This package ensures that other Debian packages needed for installation of
 some auxiliary R packages are installed.

Package: r-mathlib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: r-base-core (= ${binary:Version}), r-base-dev (= ${binary:Version})
Description: GNU R standalone mathematics library
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available from 
 CRAN, the Comprehensive R Archive Network, many also as Debian packages, 
 named 'r-cran-<name>'.
 .
 This package provides the libRmath shared and static libraries which can
 be called from standalone C or C++ code.

Package: r-base-html
Architecture: all
Priority: optional
Section: doc
Depends: ${misc:Depends}, r-base-core
Replaces: r-base (<= 1.4.1-1), r-recommended (<< 1.9.0)
Suggests: r-doc-html, mozilla | www-browser
Description: GNU R html docs for statistical computing system functions
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available from 
 CRAN, the Comprehensive R Archive Network, many also as Debian packages, 
 named 'r-cran-<name>'.
 .
 This package provides html documentation suitable for browsing with a 
 web-browser for the libraries included in the r-base package. It is not 
 a required package as the same documentation is already included for 
 on-line browsing. 

Package: r-doc-pdf
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: r-base-core, xdg-utils | pdf-viewer
Description: GNU R pdf manuals for statistical computing system
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger,

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the Debian GNU/Linux r-base package
# Copyright 1997-2003  Douglas Bates <bates@stat.wisc.edu>
# Copyright 1998-2019  Dirk Eddelbuettel <edd@debian.org>
#
# $Id: rules,v 1.3 2007/05/06 17:13:23 edd Exp edd $

corepackage	= r-base-core
devpackage	= r-base-dev
#latexpackage	= r-base-latex
pdfpackage	= r-doc-pdf
htmlpackage	= r-doc-html
nmathpackage	= r-mathlib
infopackage	= r-doc-info
recdpackage	= r-recommended
dbugpackage	= r-base-core-dbg

# for the standalone library, no sonames are assigned in the upstream Makefiles
somaj		= 1
somin		= 0
sorel		= 0
libver		= $(somaj).$(somin).$(sorel)

debbase		:= $(CURDIR)/debian
debtmp		:= $(debbase)/$(corepackage)
debdoc		:= $(debbase)/$(corepackage)/usr/share/doc/$(corepackage)
debmat		:= $(debbase)/$(nmathpackage)
debetc		:= $(debbase)/$(corepackage)/usr/lib/R/etc
debinf		:= $(debbase)/$(infopackage)
debcnf		:= $(debbase)/$(corepackage)/etc/R

## edd 24 Oct 2005 use DEB_BUILD_GNU_CPU, not DEB_BUILD_GNU_TYPE
##                 updated rules throughout
arch		:= $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
buildarch	:= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
## edd 26 Jul 2013 also use DEB_HOST_ARCH_OS to catch kFreeBSD
buildos         := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
#export DH_VERBOSE = 1

# edd 15 Aug 2001  default to blas, atlas can override it
#atlas		= --with-blas=blas
# dmb 04 Apr 2003  better to use no specify blas
# atlas			= --with-blas
# edd 28 Apr 2003  try configuring with atlas
# atlas		= --with-blas=atlas
# edd 16 Oct 2003  back to older default
#atlas		= --with-blas=blas
# edd 26 Feb 2004  point to refblas3
#atlas		= --with-blas=-lblas-3
# edd 05 Feb 2008  default blas
atlas           = --with-blas

# edd 08 Mar 2003  use the new lapack feature
# edd 27 Apr 2003  Set this to =no as we currently see numerical errors
#lapack		= --with-lapack=no
# edd 26 Feb 2004  point to lapack3
#lapack		= --with-lapack=-llapack-3
# edd 13 Oct 2004  Set this once again to =no as we still see numerical errors
#lapack		= --with-lapack=no
# edd 05 Feb 2008  switched back
# edd 05 Feb 2008  oh, no switch back to internal lapack -- see #464833
#lapack		= --with-lapack=no
# edd 05 Mar 2008  with lapack as we can now use lapack 3.1 in unstable
lapack		= --with-lapack

# edd 02 Sep 2001  default to g77 but let m68k use f2c
# edd 06 Mar 2003  enforce 3.2 versions explicitly
#		   so that on testing we will pick them over 2.95
# edd 07 Jun 2003  let's fall back to the default compilers
# edd 08 Sep 2005  real defaults, i.e. remove -3.4 strings
# edd 03 Apr 2006  switch to gfortran
# edd 04 Apr 2006  use optimflags, build per-compiler flags later
# edd 26 Jun 2007  need 4.2 for fortran linking
# edd 26 Nov 2007  4.2 is now default, so no longer set -4.2 explictly; also add f95compiler
# edd 11 Oct 2011  setting -std=gnu99 with compiler (thanks, Kurt Hornik)
fortrancompiler	= F77=gfortran
f95compiler     = gfortran
# edd 10 Jan 2016  mips currently needs gcc-4.9 (cf #810357) and big thanks to Sébastien Villemot
# edd 12 Apr 2016  mips treatment removed again after kernel fix on
#ifeq ($(arch),mips)
#compiler	= "gcc-4.9 -std=gnu99"
#else
compiler	= "gcc -std=gnu99"
#endif
cxxcompiler	= g++

# edd 31 Mar 2014
#optimflags	= -O3 -pipe
optimflags      = $(shell dpkg-buildflags --get CFLAGS)
# edd 08 Apr 2014  add CPPFLAGS
optimflags      += $(shell dpkg-buildflags --get CPPFLAGS)

# edd 22 Apr 2012  gcc-4.7 needs -O2 to build R (also #67359)
ifneq "$(shell gcc --version | head -1 | cut -d' ' -f4 | grep '^4.7')" ""
optimflags = -O2 -pipe
endif

# edd 04 Sep 2001  default compiler flags, lowered for m68k
#compilerflags	= -O2
# m68k barks when using g77, and when gcc use -O2
# edd 26 Nov 2002  switched back to g77
# edd 02 Jun 2003  switched back
# cts 04 Jun 2003  use -O1 on m68k
#ifeq ($(arch),m68k)
#fortrancompiler	= F2C=f2c
#compilerflags	= -O1
#endif

# edd 14 Nov 2003  turn blas off on arm
# edd 12 May 2010  no longer needed -- thx to Modestas Vainius
#ifeq ($(arch),arm)
#atlas		= --without-blas
#endif

## edd 09 Nov 2001  ia64 needs gcc-3.0, hppa gets it by default
#ifeq ($(arch),ia64)
#fortrancompiler = F77=g77-3.0
#compiler	= gcc-3.0
#cxxcompiler	= g++-3.0
#compilerflags	= -O2
#endif

## lamont@debian.org 06 Dec 2001  hppa needs -ffunction-sections
ifeq ($(arch),hppa)
optimflags	= -O2 -ffunction-sections
endif

## edd 20 Jun 2002	no optimisation or debugging on baby systems
## edd 02 Jun 2003	use this on arm only
## edd 12 May 2010	no longer use it on arm either -- thx Modestas
## edd 04 Aug 2010	on mips and mipsel, don't use -g
## edd 10 Jan 2016      turn all off again
##ifneq "$(findstring $(arch), m68k arm)" ""
#ifneq "$(findstring $(arch), arm)" ""
#ifneq "$(findstring $(arch), mips mipsel)" ""
#optimflags	= -g0
##optimflags	= -O0 -g0
#endif

## edd 04 Apr 2009	Alpha dies on deriv.c, trying will less optimisation
## edd 16 Apr 2009      commented-out as Kurt Roeckx applied a gcc patch
#ifeq ($(arch),alpha)
#optimflags	= -O2 -g0
#endif

## edd 09 Apr 2006	per patch from Andreas Jochens in #361604
ifeq ($(arch),powerpc64)
optimflags	+= -mminimal-toc
endif

## edd 26 Jul 2013	kFreeBSD wants -O2 per #714506
ifeq ($(buildos),kfreebsd)
optimflags	= -O2 -pipe
endif

## edd 30 Apr 2020      ppc64el aka powerpc64le has weird long double behavior breaking build
##                      so default to longdouble everywhere, but on powerpc64le
##                      also include powerpc64 and ppc64
longdouble      = --enable-long-double
ifneq "$(findstring $(arch), powerpc64le powerpc64 ppc64)" ""
longdouble      = --disable-long-double
endif

## edd 04 Apr 2006	generalize from old compilerflags to per-compiler
## edd 11 Oct 2011      -std=gnu goes to CC (thanks to Kurt Hornik)
cflags		= $(optimflags)
cxxflags	= $(optimflags)
## edd 31 Mar 2014      with thanks to Julian Gilbey in #726913
#fcflags		= $(optimflags)
fcflags 	= $(shell dpkg-buildflags --get FFLAGS)

## edd 17 Sep 2006	suggested by Brian Ripley in email dated 15 Sep 2006
#ldflags		= -Wl,-O1,-Bdirect,--hash-style=both
#ldflags		= -Wl,-O1
## edd 06 May 2007  try it
## edd 05 Feb 2008  still no go under gcc 4.3
#ldflags		= -Wl,-O1,-Bdirect,--hash-style=both
## edd 31 Mar 2014
ldflags		= $(shell dpkg-buildflags --get LDFLAGS)

## edd 16 Apr 2008	add -g to optim flags to allow for -dbg package
optimflags	+= -g

## 12 Jan 2015
## Support for #774031 uncomment the two assignment to pass a non-empty string for this to hold
#builttime       := $(shell dpkg-parsechangelog -l$(CURDIR)/debian/changelog | awk -F': ' '/Date/ {print $$2}')
#builttimestamp  := "$(builttime)"
buildtimestamp  := ""

#arch = kfreebsd-amd64
maketest:
	@echo "Hi $(arch)"
	@echo "$(findstring $(arch), i486 hppa arm)"
ifeq "$(findstring $(arch), kfreebsd-amd64 x86_64 hppa arm)" ""
	@echo "**** TRUE if the arch is NOT in the list as !find == '' ***"
endif
ifneq "$(findstring $(arch), kfreebsd-amd64 x86_64 i486 hppa arm)" ""
	@echo "**** TRUE if the arch is in list as find != '' is TRUE ***"
endif
	@echo Bye

get-orig-source: upstream
upstream:
        #links http://cran.us.r-project.org/src/base
	links http://cran.r-project.org/src/base/?M=D

upstreamdevel:
	links ftp://ftp.stat.math.ethz.ch/Software/R
        #links http://cran.us.r-project.org/src/base
        #rsync -vaC rsync.r-project.org::r-devel .

prerelease:
	links http://cran.r-project.org/src/base-prerelease

denmark:
	links http://www.biostat.ku.dk/~pd/R-release


## edd 24 Oct 2003  build is invoked by the buildd, so we would prefer to
##		    not imply build-indep; unfortunately R does not build
##		    properly without it, so we have to stick with it
## edd 15 Jan 2004  trying again on build only build: build-arch build-indep
##		    the main hook is to then have binary depend on both
##		    binary-arch and binary-indep, and those on their builds
## edd 19 Sep 2019  for source uploads also build build-indep
build: build-arch build-indep

build-arch: make-arch

## r-base 4.0.5

=== debian/changelog ===
r-base (4.0.5-1.1604.0) xenial; urgency=medium

  * Compilation for Ubuntu 16.04.7 LTS
  * debian/control Changed dependency to generic tcl-dev and tk-dev
  * Revert provides to r-api-3
  * debian/control: Use default-jdk
  * debian/control: Use texlive-generic-recommended
  * debian/control, debian/rules, debian/compat: revert to a version of
    debheler < 10
  * Added dependency on dh-r

 -- Michael Rutter <marutter@gmail.com>  Thu, 01 Apr 2021 00:28:54 +0000

r-base (4.0.5-1) experimental; urgency=medium

  * New upstream version released this morning

  [ Patch tested in informal PPA prebuilt and also sent upstream ]
  * debian/icon-class-patch/R.desktop: Updated with StartupWMClass=R_x11
  * debian/icon-class-patch/Rlogo.svg: Copy of the SVG logo for R
  * debian/icon-class-patch/rlogo_icon.png.mpack: Updated with new log
  * debian/patches/series: New patch
  * debian/patches/x11-device-window-grouping: New patch thanks to Ivan Krylov
  * debian/r-base-core.dirs: Create 48x48 icon dir
  * debian/rules: Install svg logo too
  
 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 31 Mar 2021 06:44:41 -0500

r-base (4.0.4-1.2010.3) groovy; urgency=medium

  * debian/r-base-core.dirs: Also create the directory
    usr/share/icons/hicolor/scalable/apps for the svg logo

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 23 Mar 2021 11:05:17 -0500

r-base (4.0.4-1.2010.2) groovy; urgency=medium

  * icon-class-patch/R.desktop: Add 'StartupWMClass=R_x11'
  * icon-class-patch/rlogo_icon.OLD.png.mpack: Renamed old icon
  * icon-class-patch/rlogo_icon.png.mpack: New 48x48 png from svg
  * icon-class-patch/Rlogo.svg: Copy of official logo
  * debian/rules: Also install Rlogo.svg in 'scalable' icons dir

  * debian/patches/series: Deactivate unneeded grouping patch 

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 23 Mar 2021 10:27:43 -0500

r-base (4.0.4-1.2010.1) groovy; urgency=medium

  * PPA build on Ubuntu 20.10 "groovy"
  * src/modules/X11/devX11.c: Apply patch by Ivan Krylov (posted to r-devel
    on 2021-03-22) enabling grouping of x11 plot device windows

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 22 Mar 2021 21:33:09 -0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
 Standards-Version: 4.5.1
-Build-Depends: gcc (>= 4:4.1.0), g++ (>= 4:4.1.0), gfortran (>= 4:4.1.0), libblas-dev, liblapack-dev (>= 3.1.1), tcl8.6-dev, tk8.6-dev, bison, groff-base, libncurses5-dev, libreadline-dev, debhelper-compat (= 11), texinfo (>= 4.1-2), libbz2-dev, liblzma-dev, libpcre2-dev, libpcre3-dev, libcurl4-openssl-dev | libcurl4-dev, xdg-utils, zlib1g-dev, libpng-dev, libjpeg-dev, libx11-dev, libxt-dev, x11proto-core-dev, libpango1.0-dev, libcairo2-dev, libtiff5-dev, xvfb, xauth, xfonts-base, texlive-base, texlive-latex-base, texlive-plain-generic, texlive-fonts-recommended, texlive-fonts-extra, texlive-extra-utils, texlive-latex-recommended, texlive-latex-extra, default-jdk [!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386] | openjdk-10-jdk [!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], mpack, bash-completion
+Build-Depends: gcc (>= 4:4.1.0), g++ (>= 4:4.1.0), gfortran (>= 4:4.1.0), libblas-dev, liblapack-dev (>= 3.1.1), tcl-dev, tk-dev, bison, groff-base, libncurses5-dev, libreadline-dev, debhelper, texinfo (>= 4.1-2), libbz2-dev, liblzma-dev, libpcre2-dev, libpcre3-dev, libcurl4-openssl-dev | libcurl4-dev, xdg-utils, zlib1g-dev, libpng-dev, libjpeg-dev, libx11-dev, libxt-dev, x11proto-core-dev, libpango1.0-dev, libcairo2-dev, libtiff5-dev, xvfb, xauth, xfonts-base, texlive-base, texlive-latex-base, texlive-generic-recommended, texlive-fonts-recommended, texlive-fonts-extra, texlive-extra-utils, texlive-latex-recommended, texlive-latex-extra, default-jdk [!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386] | openjdk-10-jdk [!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], mpack, bash-completion
 Vcs-Browser: https://salsa.debian.org/edd/r-base
 Vcs-Git: https://salsa.debian.org/edd/r-base.git
 Homepage: http://www.r-project.org/
